.LP
.pl 10.0i
.EQ
delim 
.EN
.po 0
.ll 7.2i
.lt 7.2i
.nr LL 7.2i
.nr LT 7.2i
.ds LH Internet Draft
.ds CH SIP
.ds RH \*(DY
.ds LF Schulzrinne/Rosenberg
.ds RF [Page %]FF
.ds CF
.ad l
.in 0
.nh
.LP
.TS
expand;
l r .
Internet Engineering Task Force	SIP WG
Internet Draft	Schulzrinne/Rosenberg
ietf-sip-srv-01.txt	Columbia U./dynamicsoft
\*(DY
Expires: June 2001
.TE
.SH
.ce 99
SIP: Session Initiation Protocol \*- Locating SIP Servers
.ce 0
.sp
.ti 0
STATUS OF THIS MEMO
.LP
.in 3
This document is an Internet-Draft and is in full conformance
with all provisions of Section 10 of RFC2026.
.LP
Internet-Drafts are working documents of the Internet Engineering Task
Force (IETF), its areas, and its working groups.  Note that other
groups may also distribute working documents as Internet-Drafts.
.LP 
Internet-Drafts are draft documents valid for a maximum of six months
and may be updated, replaced, or obsoleted by other documents at any
time.  It is inappropriate to use Internet-Drafts as reference
material or to cite them other than as "work in progress".
.LP
The list of current Internet-Drafts can be accessed at
http://www.ietf.org/ietf/1id-abstracts.txt
.LP 
To view the list Internet-Draft Shadow Directories, see
http://www.ietf.org/shadow.html.
.LP
.sp
.ti 0
Abstract
.fi
.in 3
.LP
This document describes how a SIP client locates a SIP server based on
the Request-URI or a preconfigured outbound proxy server. This
document updates the process described in RFC 2543.
.sp
.LP
.ti 0
1 Introduction
.XS
1          Introduction
.XE
.in 3
.LP
This document updates Sections 1.3 and 1.4.2 and supersedes Appendix D
of RFC 2543 [1]. Inter alia, it defines the term outbound
proxy and replaces references to the obsoleted RFC 2052 with current
references to RFC 2782.
.LP
.ti 0
1.1 Terminology
.XS
1.1        Terminology
.XE
.in 3
.LP
In this document, the key words \*QMUST\*U, \*QMUST NOT\*U,
\*QREQUIRED\*U, \*QSHALL\*U, \*QSHALLNOT\*U, \*QSHOULD\*U,
\*QSHOULD NOT\*U, \*QRECOMMENDED\*U, \*QMAY\*U, and \*QOPTIONAL\*U
are to be interpreted as described in RFC 2119 [2] and
indicate requirement levels for compliant SIP implementations.
.LP
.ti 0
1.2 Definitions
.XS
1.2        Definitions
.XE
.in 3
.RS
.XP
Outbound proxy: A 
.I
proxy
.R
that is located near the originator
of requests. It receives all outgoing requests 
.B
from
.R
a particular
UAC, including those requests whose Request-URLs identify a
host other than the outbound proxy. The outbound proxy sends these
requests, after any local processing, to the address indicated in the
Request-URI. (All other proxy servers are simply referred as
proxies, not 
.I
inbound
.R
proxies.)
.RE
.LP
.ti 0
2 Locating a SIP Server
.XS
2          Locating a SIP Server
.XE
.in 3
.LP
When a client wishes to send a request, the client either sends it to a
locally configured SIP proxy server, the so-called 
.I
outbound proxy
.R
,
independent of the Request-URI, or sends it to the IP address
and port corresponding to the Request-URI. The outbound proxy
can be configured by any mechanism, including DHCP
[3] and can be specified either as a set of
parameters such as network address or host name, protocol port and
transport protocol, or as a SIP URI.
.LP
If the Request-URI is used, the client needs to determine the
protocol, port and IP address of a server to which to send the
request. A client SHOULD follow the steps below to obtain this
information.
.LP
Clients MUST re-run the above selection algorithm, re-drawing any
random numbers involved, once per transaction rather than for each
request, i.e., requests within the same transaction MUST be sent to
the same network address. Thus, the same address is used for the
request, any retransmissions, any associated CANCEL requests and
ACK requests for non-2xx responses. However, ACKs for 2xx
responses use another iteration of the selection algorithm. (Indeed, in
many cases, they may have different request URIs.)
.LP
A stateless proxy can accomplish this, for example, by using the modulo
N of a hash of the Call-ID value or some other combination of
transaction-identifying headers as the uniform random number described
in the weighting algorithm of RFC 2782. Here, N is the sum of weights
within the priority class.
.LP
A client SHOULD be able to interpret explicit network notifications
(such as ICMP messages) which indicate that a server is not reachable,
rather than relying solely on timeouts. (For socket-based programs:
For TCP, 
.R
connect()
.R
returns 
.R
ECONNREFUSED
.R
if the client could
not connect to a server at that address. For UDP, the socket needs to
be bound to the destination address using 
.R
connect()
.R
rather than
.R
sendto()
.R
or similar so that a second 
.R
write()
.R
or 
.R
send()
.R
fails with 
.R
ECONNREFUSED
.R
if there is no server listening) If the
client finds the server is not reachable at a particular address, it
SHOULD behave as if it had received a 400-class error response to
that request.
.LP
The client tries to find one or more addresses for the SIP server by
querying DNS. If a step elicits no addresses, the client continues to
the next step. However if a step elicits one or more addresses, but no
SIP server at any of those addresses responds, then the client concludes
the server is down and does not continue on to the next step.
.LP
If the client is configured with the address of an outbound proxy, the
parameters of the outbound proxy, including transport protocol and port,
become the 
.I
destination
.R
used below.
.LP
If there is no outbound proxy, the destination is the
Request-URI. The destination address is the maddr
parameter if it exists and the host element if not. The
transport protocol is the transport parameter.
.LP
The service identifier for DNS SRV records [4] is \*Q_sip\*U.
.RS
.IP 1.
If the destination address is a numeric IP address, the client
contacts the server at the given address and the port number specified
in the SIP-URI or, if not specified, the default port (5060).
.IP
If the destination specifies a protocol, the client contacts the server
using that protocol. If no protocol is specified, the client first
tries UDP. If attempt fails, or if the client does not support UDP but
supports other protocols, it tries those protocols in some
implementation-defined order.
.IP
The client then skips the remaining steps.
.IP 2.
If the destination specifies no port number or port number 5060,
the transport protocol determines the use of one of the following three
rules:
.RS
.IP - 2
If the destination does not specify a transport protocol, DNS SRV
records are retrieved according to RFC 2782 [4]. The results
of the query or queries are merged and ordered based on priority,
keeping only records with transport protocols that the client supports.
Then, the searching technique outlined in RFC 2782 [4] is
used to select servers in order. Server selection across requests is
independent of previous choices, except as noted above for stateless
proxies. Message length or other request properties do not influence
the server selection. The client attempts to contact each server in the
order listed, at the port number specified in the SRV record. If none
of the servers can be contacted, the client gives up. If there are no
SRV records (with any transport protocol), DNS address records are used,
as described below.
.IP - 2
If a transport protocol is specified and this protocol is
supported by the client, the procedure in the paragraph above is used,
limited to DNS resource records with the transport protocol specified in
the SIP-URI.
.IP - 2
If the transport protocol specified is not supported by the
client, the client gives up.
.RE
.IP
If there are no SRV records, the next step applies.
.IP 3.
If the destination specifies a port number other than 5060 or if
there are no SRV records, the client queries the DNS server for address
records for the destination address. Address records include A RR's,
AAAA RR's, or other similar records, chosen according to the client's
network protocol capabilities.
.IP
If the DNS server returns no address records, the client gives up. If
there are address records, the same rules as in step 2 apply.
.RE
.LP
Clients MUST NOT cache query results except according to the rules in
RFC 1035 [5].
.LP
.ti 0
3 Security Considerations
.XS
3          Security Considerations
.XE
.in 3
.LP
The security considerations in RFC 2543 [1] apply.
.LP
.ti 0
4 Authors' Addresses
.XS
4          Authors' Addresses
.XE
.in 3
.LP
Henning Schulzrinne
.br
Dept. of Computer Science
.br
Columbia University
.br
1214 Amsterdam Avenue
.br
New York, NY 10027
.br
USA
.br
electronic mail:  schulzrinne@cs.columbia.edu
.LP
Jonathan Rosenberg
.br
dynamicsoft
.br
72 Eagle Rock Ave
.br
East Hanover, NJ 07936
.br
USA
.br
electronic mail:  jdrosen@dynamicsoft.com
.LP
.ti 0
5 Bibliography
.XS
5          Bibliography
.XE
.in 3
.LP
[1] 
M. Handley, H. Schulzrinne, E. Schooler, and J. Rosenberg, \*QSIP: session
initiation protocol,\*U Request for Comments 2543, Internet Engineering Task
Force, Mar. 1999.
.LP
[2] 
S. Bradner, \*QKey words for use in RFCs to indicate requirement levels,\*U
Request for Comments 2119, Internet Engineering Task Force, Mar. 1997.
.LP
[3] 
G. Nair and H. Schulzrinne, \*QDHCP option for SIP servers,\*U Internet
Draft, Internet Engineering Task Force, Apr. 2000.
Work in progress.
.LP
[4] 
A. Gulbrandsen, P. Vixie, and L. Esibov, \*QA DNS RR for specifying the
location of services (DNS SRV),\*U Request for Comments 2782, Internet
Engineering Task Force, Feb. 2000.
.LP
[5] 
P. V. Mockapetris, \*QDomain names - implementation and specification,\*U Request
for Comments 1035, Internet Engineering Task Force, Nov. 1987.
.LP
.SH 2
Full Copyright Statement
.LP
Copyright (c) The Internet Society (2001). All Rights Reserved.
.LP
This document and translations of it may be copied and furnished to
others, and derivative works that comment on or otherwise explain it or
assist in its implementation may be prepared, copied, published and
distributed, in whole or in part, without restriction of any kind,
provided that the above copyright notice and this paragraph are included
on all such copies and derivative works. However, this document itself
may not be modified in any way, such as by removing the copyright notice
or references to the Internet Society or other Internet organizations,
except as needed for the purpose of developing Internet standards in
which case the procedures for copyrights defined in the Internet
Standards process must be followed, or as required to translate it into
languages other than English.
.LP
The limited permissions granted above are perpetual and will not be
revoked by the Internet Society or its successors or assigns.
.LP
This document and the information contained herein is provided on an "AS
IS" basis and THE INTERNET SOCIETY AND THE INTERNET ENGINEERING TASK
FORCE DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT
LIMITED TO ANY WARRANTY THAT THE USE OF THE INFORMATION HEREIN WILL NOT
INFRINGE ANY RIGHTS OR ANY IMPLIED WARRANTIES OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE.
